
package de.ivu.elect.presentation.benutzerverwaltung.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.benutzerverwaltung.entity.Benutzer;
import de.ivu.elect.business.benutzerverwaltung.entity.Rolle;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.benutzerverwaltung.RolleEditView;

@Named(RolleDeleteAction.COMPONENT_NAME)
public class RolleDeleteAction extends AbstractRolleAction {

  public static final String COMPONENT_NAME = "rolleDeleteAction";

  private static final long serialVersionUID = 1L;

  @View
  @Inject
  private RolleEditView rolleEditView;

  public RolleDeleteAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.ROLLE_DELETE;
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Rolle rolle) {
    // Deaktivieren, wenn die zu löschende Rolle Teil der zugewiesenen Rollen des gerade angemeldeten Benutzers ist
    Benutzer login = principal.getLogin();
    if (login==null){
      return true;
    }
    return login.getRolles().contains(rolle);
  }

  @Override
  protected String doIt(Rolle rolle) {
    rolleEditView.setEntity(rolle);

    return null;
  }

  @Override
  protected boolean isFireChangeEvent() {
    return true;
  }

  @Override
  public String getDialogName() {
    return "DeleteConfirm";
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.delete";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconDelete();
  }
}
